#include <function_cache.hpp>
#include <scoped_timer.hpp>
#include <iostream>
#include <future>

using namespace std;

uint64_t fib(uint64_t n)
{
    if (n < 2)
        return n;

    future<uint64_t> n1 = async(fib, n - 1);
    future<uint64_t> n2 = async(fib, n - 2);

    return n1.get() + n2.get();
}

int main()
{
    scoped_timer timer("function cache test");

    //function_cache_old - usage
    auto fib_cached_old = add_cache_old(function<decltype(fib)>(fib));

    //function_cache - usage
    auto fib_cached = add_cache(&fib);

    timer.add_step("init - done");

    cout << fib_cached(15) << endl;
    timer.add_step("function_cache (without cache) - done");
    cout << fib_cached(15) << endl;
    timer.add_step("function_cache (with cache) - done");

    cout << fib_cached_old(15) << endl;
    timer.add_step("function_cache_old (without cache) - done");
    cout << fib_cached_old(15) << endl;
    timer.add_step("function_cache_old (with cache) - done");

    return 0;
}
